/* ./stimulation/stimulation_mesh.cpp 
**********************************
Copyright EPFL and INRIA

author : Guillaume ANCIAUX (guillaume.anciaux@epfl.fr, g.anciaux@laposte.net)

The LibMultiScale is a C++ parallel framework for the multiscale
coupling methods dedicated to material simulations. This framework
provides an API which makes it possible to program coupled simulations
and integration of already existing codes.

This Project is done in a collaboration between 
EPFL within ENAC-LSMS (http://lsms.epfl.ch/) and 
INRIA Bordeaux, ScAlApplix (http://www.labri.fr/projet/scalapplix/). 

This software is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-C
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.
***********************************/

#define NEED_LIBMESH
#define LOCAL_MODULE MOD_STIMULATION

#include "../common/lm_common.h"
#include "stimulation.h"
#include "../continuum/lib_continuum.h"

// template <class T,unsigned int Dim>
// void StimulationReservoirHammerberg<T,Dim>::Stimulate(int stage)//(double largeure,Boule & b,double L)
// {
//   LOG("Stimulation Pgaussian on " << domain.myName() << " domain");
//   double k = 2*Pi/this->largeure;


//   /* definition des types */
//   typedef typename T::_Vec_ _Vec_;
//   typedef typename T::_Model_ _Model_;
//   typedef typename T::RefElt RefElt;
//   typedef typename T::RefNd RefNd;
//   typedef typename T::ContenerElems ContenerElems;
//   typedef typename T::IteratorElems IteratorElems;
//   typedef typename T::ContenerNodes ContenerNodes;
//   typedef typename T::IteratorNodes IteratorNodes;


//   /* structures pour manipuler les noeuds */
//   ContenerNodes & cNd = this->domain.getContenerNodes();
//   IteratorNodes & itNd = cNd.GetIterator();

//   for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
//     {
//       double x=0,y=0,z=0;
//       x = n.GetPositions0(0);
//       if (Dim > 1)
// 	y = n.GetPositions0(1);
//       if (Dim > 2)
// 	z = n.GetPositions0(2);

//       if (this->geom->Contient(x,y,z)){
// 	LOG("procede a la stimulation du noeud a la position " << x 
// 	    << " " << y << " " << z);
	
// 	double d;
// 	d = this->geom->DistToCenter(x,y,z);
	
// 	double deformation = this->intensity*(exp(-1.0*ipow(k*d,2)));
	
// 	double vecX,vecY,vecZ;
	
// 	if (Dim==1){
// 	  n.SetDeplacements(0,deformation);
// 	}
	
// 	if (Dim==2){
// 	  vecX = this->geom->NormToCenter(0,x,y);
// 	  vecY = this->geom->NormToCenter(1,x,y);
// 	  n.SetDeplacements(0,deformation*vecX);
// 	  n.SetDeplacements(1,deformation*vecY);
// 	}
	
// 	if (Dim==3){
// 	  vecX = this->geom->NormToCenter(0,x,y,z);
// 	  vecY = this->geom->NormToCenter(1,x,y,z);
// 	  vecZ = this->geom->NormToCenter(2,x,y,z);
// 	  n.SetDeplacements(0,deformation*vecX);
// 	  n.SetDeplacements(1,deformation*vecY);
// 	  n.SetDeplacements(2,deformation*vecZ);
// 	}
//       }
	  
//     }


//   /* structures pour manipuler les noeuds */
//   ContenerNodes & cNd = this->domain.getContenerNodes();
//   IteratorNodes & itNd = cNd.GetIterator();

//   for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
//     {
//       double x=0,y=0,z=0;
//       x = n.GetPositions0(0);
//       if (Dim > 1)
// 	y = n.GetPositions0(1);
//       if (Dim > 2)
// 	z = n.GetPositions0(2);

//       if (this->geom->Contient(x,y,z)){
// 	LOG("procede a la stimulation du noeud a la position " << x 
// 	    << " " << y << " " << z);
	
// 	double d;
// 	d = this->geom->DistToCenter(x,y,z);
	
// 	double deformation = this->intensity*(exp(-1.0*ipow(k*d,2)));
	
// 	double vecX,vecY,vecZ;
	
// 	if (Dim==1){
// 	  n.SetDeplacements(0,deformation);
// 	}
	
// 	if (Dim==2){
// 	  vecX = this->geom->NormToCenter(0,x,y);
// 	  vecY = this->geom->NormToCenter(1,x,y);
// 	  n.SetDeplacements(0,deformation*vecX);
// 	  n.SetDeplacements(1,deformation*vecY);
// 	}
	
// 	if (Dim==3){
// 	  vecX = this->geom->NormToCenter(0,x,y,z);
// 	  vecY = this->geom->NormToCenter(1,x,y,z);
// 	  vecZ = this->geom->NormToCenter(2,x,y,z);
// 	  n.SetDeplacements(0,deformation*vecX);
// 	  n.SetDeplacements(1,deformation*vecY);
// 	  n.SetDeplacements(2,deformation*vecZ);
// 	}
//       }
	  
//     }


//   this->domain.fixChanges();

//   delete &itNd;
// }


template <class Domain,unsigned int Dim>
void StimulationShear<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation Shear on " << this->domain.myName() << " domain",DBG_INFO);

  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::RefElt RefElt;

  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  double epsilonxy = this->intensity;

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();
  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);


      if (!geom || geom->Contains(x,y,z)){
	double ux = 0;
	double uz = 0;
	if  (fixed) ux = epsilonxy*(y);
	else ux = epsilonxy*(y+n.GetDeplacements(1));
	if (fixed) uz = epsilonzy*y;
	else uz = epsilonzy*(y+n.GetDeplacements(1));

	double depX = n.GetDeplacements(0);
	double depZ = n.GetDeplacements(2);	
	if (fixed) n.SetDeplacements(0,ux);
	else n.SetDeplacements(0,depX+ux);
	if (fixed) n.SetDeplacements(2,uz);
	else n.SetDeplacements(2,depZ+uz);

	DUMP("procede a la stimulation du noeud a la position " << x 
	     << " " << y << " " << z << " with value " << epsilonzy,DBG_DETAIL);
      }
      
    }

  this->domain.fixChanges();

}
 template <class Domain,unsigned int Dim>
void StimulationDisloEdge<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation DisloEdge on " << this->domain.myName() << " domain",DBG_INFO);

  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::RefElt RefElt;

  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);
  else FATAL("this stimulator (DisloEdge) MUST have a geometry passed by keyword GEOMETRY !!");
  Cube & cube = GeomTools::GetBoundingBox(*geom);
  double xmin_2 = cube.Xmin();xmin_2*=xmin_2;
  double xmax_2 = cube.Xmax();xmax_2*=xmax_2;  

  double epsilon = 1e-30;
  double width = this->intensity;

  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();
  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);

      if (geom->Contains(x,y,z)){
	DUMP("procede a la stimulation du noeud a la position " << x 
	    << " " << y << " " << z,DBG_DETAIL);

        x=0;
	double x0 = n.GetPositions0(0)-posx;
	y = n.GetPositions0(1)-posy;
	double y_2 = y; y_2 *= y_2;
	double x_2 = 0;

	double ux=0,uy=0,depX=0,depY=0;

	for (int i = 0 ; i < resolution ; ++i){
	  x = x0 +(((double)i)/resolution - .5)*width;
	  x_2 = x; x_2 *= x_2;	  
	  ux +=  (burgers/(2*Pi)*
	    (
	     -signe(y)*Pi/2.0 -atan(x/(y+epsilon)) + x*y/
	     (
	      2*(1-nu)*(x_2 + y_2)
	      )
	     
	     ) // + epsilonxy*y
		  )/resolution;
	
	if (Dim>1)
	  uy += -burgers/(2*Pi)*((1-2*nu)/(4*(1-nu))*(log(x_2 + y_2) - 0.5*(log(xmin_2) + log(xmax_2))) /* Deplacement au loin /y nul. */
				+ (x_2 - y_2)/
				(
				 4*(1-nu)*(x_2 + y_2)
				 )
				
				)/resolution;
	}
	
	depX = n.GetDeplacements(0);
	if (Dim > 1)
	depY = n.GetDeplacements(1);

	n.SetDeplacements(0,depX+ux);
	if (Dim>1)
	  n.SetDeplacements(1,depY+uy);

      }
	  
    }

  this->domain.fixChanges();

}

 template <class Domain,unsigned int Dim>
void StimulationDisloScrew<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation DisloScrew on " << this->domain.myName() << " domain",DBG_INFO);

  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::RefElt RefElt;

  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);
  else FATAL("this stimulator (DisloScrew) MUST have a geometry passed by keyword GEOMETRY !!");
  Cube & cube = GeomTools::GetBoundingBox(*geom);
  double xmin_2 = cube.Xmin();xmin_2*=xmin_2;
  double xmax_2 = cube.Xmax();xmax_2*=xmax_2;  

  double epsilon = 1e-30;
  double width = this->intensity;

  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();
  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);

      if (geom->Contains(x,y,z)){
	x=0;
	double x0 = n.GetPositions0(0)-posx;
	y = n.GetPositions0(1)-posy;

	double uz=0,depZ=0;

	for (int i = 0 ; i < resolution ; ++i){
	  x = x0 +(((double)i)/resolution - .5)*width;
	  int sign_y = (y < 0) ? -1 : 1; 
	  uz +=  (burgers/(2*Pi)*(-sign_y*Pi/2 - atan(x/y) ))/resolution;
	}
	depZ = n.GetDeplacements(2);
	n.SetDeplacements(2,depZ+uz);
	DUMP("procede a la stimulation du noeud a la position " << x 
	     << " " << y << " " << z << " with value " << depZ+uz,DBG_DETAIL);
      }
    }
  
  this->domain.fixChanges();
  
}


template <class Domain,unsigned int Dim>
void StimulationWall<Domain,Dim>::Stimulate(int stage)
{
}


template <class Domain,unsigned int Dim>
void StimulationDepUni<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation DepUni on " << this->domain.myName() << " domain",DBG_INFO);

  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::RefElt RefElt;

  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;


  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();
  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  //compute intensity
  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);

      if (geom->Contains(x,y,z)){
	DUMP("procede a la stimulation du noeud a la position " << x 
	    << " " << y << " " << z,DBG_DETAIL);

	double ux = n.GetDeplacements(0);
	n.SetDeplacements(0,ux+vecX*this->increment);
	if (Dim>1){
	  double uy = n.GetDeplacements(1);  
	  n.SetDeplacements(1,uy+vecY*this->increment);
	}
	if (Dim == 3){
	  double uz = n.GetDeplacements(2);  
	  n.SetDeplacements(2,uz+vecZ*this->intensity);
	}
      }
	  
    }

  this->domain.fixChanges();

  delete &itNd;
}

template <class Domain,unsigned int Dim>
void StimulationDepGauss<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation Pgaussian on " << this->domain.myName() << " domain",DBG_INFO);
  double k = 2*Pi/this->largeure;

  typedef typename Domain::RefElt RefElt;
  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::ContenerElems ContenerElems;
  typedef typename Domain::IteratorElems IteratorElems;
  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  if (dynamic_cast<Ball*>(geom)==NULL)
    FATAL("With a gaussian displacement stimulation, only a spherical geometrie can be attached -> check geometries");
  Ball & b = static_cast<Ball &>(*geom);

  double dist_front = (b.Rmax() - b.Rmin())/2;


  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();

  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);

      if (b.Contains(x,y,z)){
	DUMP("procede a la stimulation du noeud a la position " << x 
	    << " " << y << " " << z,DBG_DETAIL);
	
	double d;
	d = b.DistToCenter(x,y,z);

	if (Dim > 1)
	  d = d - dist_front;
	
	double deformation = this->intensity*(exp(-1.0*ipow(k*d,2)));
	
	double vecX,vecY,vecZ;
	
	if (Dim==1){
	  n.SetDeplacements(0,deformation);
	}
	
	if (Dim==2){
	  vecX = b.NormToCenter(0,x,y);
	  vecY = b.NormToCenter(1,x,y);
	  n.SetDeplacements(0,deformation*vecX);
	  n.SetDeplacements(1,deformation*vecY);
	}
	
	if (Dim==3){
	  vecX = b.NormToCenter(0,x,y,z);
	  vecY = b.NormToCenter(1,x,y,z);
	  vecZ = b.NormToCenter(2,x,y,z);
	  n.SetDeplacements(0,deformation*vecX);
	  n.SetDeplacements(1,deformation*vecY);
	  n.SetDeplacements(2,deformation*vecZ);
	}
      }
	  
    }

  this->domain.fixChanges();

  delete &itNd;
}

template <class Domain,unsigned int Dim>
void StimulationDepPlan<Domain,Dim>::Stimulate(int stage)
{
  if (!(stage & this->stage_mask)) return;
  DUMP("Stimulation Plan on " << this->domain.myName() << " domain",DBG_INFO);
  double k = 2*Pi/this->largeure;

  typedef typename Domain::RefElt RefElt;
  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::ContenerElems ContenerElems;
  typedef typename Domain::IteratorElems IteratorElems;
  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  double cx=0,cy=0,cz=0;

  if (this->g != -1){
    Geometry * geom = NULL;
    geom = GeometryManager::GetGeometry(this->g);
    cx = geom->Center(0);
    cy = geom->Center(1);
    cz = geom->Center(2);
  }

  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();

  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim > 2)
	z = n.GetPositions0(2);

      double d=0;
      switch (axis){
      case 0: d = fabs(x-cx);break;
      case 1: d = fabs(y-cy);break;
      case 2: d = fabs(z-cz);break;	  
      default : FATAL("this should not append");
      }
      double deformation = this->intensity*(exp(-1.0*ipow(k*d,2)));
      
      if (Dim==1) n.SetDeplacements(axis,deformation);
      if (Dim==2) n.SetDeplacements(axis,deformation);
      if (Dim==3) n.SetDeplacements(axis,deformation);
      
    }

  this->domain.fixChanges();

  delete &itNd;
}


template <class T,unsigned int Dim>
void StimulationSinusoide<T,Dim>::Stimulate(int stage)//(double k,Ball & b,double L){
{
DUMP("pas encore implemente",DBG_INFO);
}

template <class T,unsigned int Dim>
void StimulationModulation<T,Dim>::Stimulate(int stage)//ppliqueModulation(double longueur_onde,Ball & b,double L){
{
DUMP("pas encore implemente",DBG_INFO);
}

template <class T,unsigned int Dim>
void StimulationVelGauss<T,Dim>::Stimulate(int stage)//iqueVGaussienne(double k,Ball & b,double L,int direction){
{
DUMP("pas encore implemente",DBG_INFO);
}

template <class Domain,unsigned int Dim>
void StimulationRAZ<Domain,Dim>::Stimulate(int stage)
{
  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;


  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    //for (int i = first ; i< last ; ++i)
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim == 3)
	z = n.GetPositions0(2);

      if (!geom || geom->Contains(x,y,z)){
	
	
	if (flag_reset_vel) n.SetVitesses(0,n.GetVitesses(0)*COEF);
	if (flag_reset_dep) n.SetDeplacements(0,0.0);
	if (flag_reset_force) n.SetForces(0,n.GetForces(0)*COEF);
	
	if (Dim > 1){
	  if (flag_reset_vel) n.SetVitesses(1,n.GetVitesses(1)*COEF);
	  if (flag_reset_dep) n.SetDeplacements(1,0.0);
	if (flag_reset_force) n.SetForces(1,n.GetForces(1)*COEF);
	}
	if (Dim == 3){
	  if (flag_reset_vel) n.SetVitesses(2,n.GetVitesses(2)*COEF);
	  if (flag_reset_dep) n.SetDeplacements(2,0.0);
	  if (flag_reset_force) n.SetForces(2,n.GetForces(2)*COEF);	  
	}
      }
    }
  delete &itNd;
}


template <class Domain,unsigned int Dim>
void StimulationMatiereLancee<Domain,Dim>::Stimulate(int stage)
{
  /* definition des types */
  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;


  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();
  
  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  Cube & cube = GeomTools::GetBoundingBox(*geom);

  //  Attach_debugger(false);

  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x,y,z;


      switch (axe){
      case 0 : x = n.GetPositions0(0);
	n.SetVitesses(0,x/cube.Xmax()*this->intensity);
	if (Dim > 1)
	  n.SetVitesses(1,0);
 	if (Dim == 3)
 	  n.SetVitesses(2,0);
	break;
      case 1 :
	if (Dim > 1){
	  y = n.GetPositions0(1);
	  n.SetVitesses(1,y/cube.Ymax()*this->intensity);
	  n.SetVitesses(0,0);
	}
	if (Dim == 3)
	  n.SetVitesses(2,0);
	break;
      case 2: 
	if (Dim == 3){
	  z = n.GetPositions0(2);
	  n.SetVitesses(2,z/cube.Zmax()*this->intensity);
	  n.SetVitesses(0,0);n.SetVitesses(1,0);
	}
	break;
      }
    } 
  this->domain.fixChanges();

  delete &itNd;
  delete &cube;
}


template <class Domain,unsigned int Dim>
void StimulationImposedDep<Domain,Dim>::Stimulate(int stage)
{
  typedef typename Domain::RefNd RefNd;
  typedef typename Domain::ContenerNodes ContenerNodes;
  typedef typename Domain::IteratorNodes IteratorNodes;

  /* structures pour manipuler les noeuds */
  ContenerNodes & cNd = this->domain.getContenerNodes();
  IteratorNodes & itNd = cNd.GetIterator();

  Geometry * geom = NULL;
  if (this->g != -1)
    geom = GeometryManager::GetGeometry(this->g);

  Cube & cube = GeomTools::GetBoundingBox(*geom);

  for (RefNd n = itNd.GetFirst();!itNd.end();n = itNd.GetNext())
    {
      double x=0,y=0,z=0;
      x = n.GetPositions0(0);
      if (Dim > 1)
	y = n.GetPositions0(1);
      if (Dim == 3)
	z = n.GetPositions0(2);
      
      if(geom->Contains(x,y,z)){
	double vitesse_y = y/cube.Ymax()*this->intensity;
	double dep = this->step*vitesse_y;
	n.SetDeplacements(0,dep);
	if (Dim > 1)
	  n.SetDeplacements(1,dep);
	if (Dim > 2)
	  n.SetDeplacements(2,dep);
      }
      
    }
  //  u.close();
}

template <class Domain,unsigned int Dim>
void StimulationImpulse<Domain,Dim>::Stimulate(int stage)
{
}


#ifdef USING_LIBMESH
template class StimulationDepUni<DomainLibMesh<1>,1>;
template class StimulationDepUni<DomainLibMesh<2>,2>;
template class StimulationDepUni<DomainLibMesh<3>,3>;

template class StimulationDepGauss<DomainLibMesh<1>,1>;
template class StimulationDepGauss<DomainLibMesh<2>,2>;
template class StimulationDepGauss<DomainLibMesh<3>,3>;

template class StimulationDepPlan<DomainLibMesh<1>,1>;
template class StimulationDepPlan<DomainLibMesh<2>,2>;
template class StimulationDepPlan<DomainLibMesh<3>,3>;

template class StimulationSinusoide<DomainLibMesh<1>,1>;
template class StimulationSinusoide<DomainLibMesh<2>,2>;
template class StimulationSinusoide<DomainLibMesh<3>,3>;

template class StimulationModulation<DomainLibMesh<1>,1>;
template class StimulationModulation<DomainLibMesh<2>,2>;
template class StimulationModulation<DomainLibMesh<3>,3>;

template class StimulationRAZ<DomainLibMesh<1>,1>;
template class StimulationRAZ<DomainLibMesh<2>,2>;
template class StimulationRAZ<DomainLibMesh<3>,3>;

template class StimulationImposedDep<DomainLibMesh<1>,1>;
template class StimulationImposedDep<DomainLibMesh<2>,2>;
template class StimulationImposedDep<DomainLibMesh<3>,3>;

template class StimulationVelGauss<DomainLibMesh<1>,1>;
template class StimulationVelGauss<DomainLibMesh<2>,2>;
template class StimulationVelGauss<DomainLibMesh<3>,3>;

template class StimulationMatiereLancee<DomainLibMesh<1>,1>;
template class StimulationMatiereLancee<DomainLibMesh<2>,2>;
template class StimulationMatiereLancee<DomainLibMesh<3>,3>;

template class StimulationImpulse<DomainLibMesh<1>,1>;
template class StimulationImpulse<DomainLibMesh<2>,2>;
template class StimulationImpulse<DomainLibMesh<3>,3>;

template class StimulationDisloEdge<DomainLibMesh<1>,1>;
template class StimulationDisloEdge<DomainLibMesh<2>,2>;
template class StimulationDisloEdge<DomainLibMesh<3>,3>;
template class StimulationDisloScrew<DomainLibMesh<1>,1>;
template class StimulationDisloScrew<DomainLibMesh<2>,2>;
template class StimulationDisloScrew<DomainLibMesh<3>,3>;

#endif


#ifdef USING_MECA1D
template class StimulationDepUni<DomainMeca1D,1>;
template class StimulationDepGauss<DomainMeca1D,1>;
template class StimulationDepPlan<DomainMeca1D,1>;
template class StimulationSinusoide<DomainMeca1D,1>;
template class StimulationModulation<DomainMeca1D,1>;
template class StimulationRAZ<DomainMeca1D,1>;
template class StimulationImposedDep<DomainMeca1D,1>;
template class StimulationVelGauss<DomainMeca1D,1>;
template class StimulationMatiereLancee<DomainMeca1D,1>;
template class StimulationImpulse<DomainMeca1D,1>;
template class StimulationDisloEdge<DomainMeca1D,1>;
template class StimulationDisloScrew<DomainMeca1D,1>;
#endif

#ifdef USING_SIMULPACK
template class StimulationDepUni<DomainSimulPack<3>,3>;
template class StimulationDepGauss<DomainSimulPack<2>,2>;
template class StimulationDepGauss<DomainSimulPack<3>,3>;
template class StimulationDepPlan<DomainSimulPack<3>,3>;
template class StimulationSinusoide<DomainSimulPack<3>,3>;
template class StimulationModulation<DomainSimulPack<3>,3>;
template class StimulationRAZ<DomainSimulPack<3>,3>;
template class StimulationImposedDep<DomainSimulPack<3>,3>;
template class StimulationVelGauss<DomainSimulPack<3>,3>;
template class StimulationMatiereLancee<DomainSimulPack<3>,3>;
template class StimulationImpulse<DomainSimulPack<3>,3>;
template class StimulationImpulse<DomainSimulPack<2>,2>;
template class StimulationDisloEdge<DomainSimulPack<3>,3>;
template class StimulationDisloScrew<DomainSimulPack<3>,3>;
template class StimulationWall<DomainSimulPack<3>,3>;
template class StimulationShear<DomainSimulPack<3>,3>;
#endif


